/**
 * Copyright 2008, Daniel Molina Cabrera <danimolina@gmail.com>
 * 
 * This file is part of software Realea
 * 
 * Realea is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Realea is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _FUNCEC08_H

#define _FUNCEC08_H 1

#include <realea/common/real.h>
#include <string>

/**
 * This function must be called before it can be used any of the other functions
 *
 * @param func_number function number (from 1 to 6).
 */
void init_cec2008(int func_number);

/**
 * This function eval the individual x using the function setting with init_cec2008
 * @param x solution, it is an array of tGen.
 * @param dim dimension size
 */
double eval_cec2008(const tGen *x, int dim); 


void getInfo_cec2008(unsigned fun, string &name, double &min, double &max, double &optime);

/**
 * This function releases all resources reserved by init_cec2008. 
 * When it is used, it can not be used getInfo_cec2008 or eval_cec2008 until 
 * init_cec2008 is called again.
 */
void finish_cec2008(void);

#endif
