/**
 * Copyright 2008, Daniel Molina Cabrera <danimolina@gmail.com>
 * 
 * This file is part of software Realea
 * 
 * Realea is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Realea is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _FUNCTIONS
#define _FUNCTIONS

#include <realea/common/real.h>

tFitness sphere(const tGen *,int);
tFitness step(const tGen *x, int dim); 
tFitness step2(const tGen *x, int dim); 
tFitness branin(const tGen *,int);
tFitness b2(const tGen *,int);
tFitness ackley(const tGen *x, int n);
tFitness easom(const tGen *,int);
tFitness goldstein_price(const tGen *,int);
tFitness shubert(const tGen *,int);
tFitness beale(const tGen *,int);
tFitness booth(const tGen *,int);
tFitness matyas(const tGen *,int);
tFitness sixhumpcamelback(const tGen *x, int n);
tFitness schwefel(const tGen *,int);
tFitness schwefel_226(const tGen *x, int n);
tFitness rosenbrock(const tGen *,int);
tFitness zakharov(const tGen *,int);
tFitness rastrigin(const tGen *,int);
tFitness rastrigin_funcR(const tGen *, int); 
tFitness rastrigin_funcS(const tGen *, int); 
tFitness griewank(const tGen *,int);
tFitness Trid(const tGen *, int);
tFitness dejoung(const tGen *, int);
tFitness Hartman34(const tGen *, int);
tFitness Hartman64(const tGen *, int);
tFitness colville(const tGen *, int);
tFitness Perm(const tGen *, int);
tFitness Perm_0(const tGen *, int);
tFitness PowerSum(const tGen *, int);
tFitness sum_squares(const tGen *, int);
tFitness powell(const tGen *, int);
tFitness levy(const tGen *, int);
tFitness shekel5(const tGen *, int);
tFitness shekel7(const tGen *, int);
tFitness shekel10(const tGen *, int);
tFitness dixon_price(const tGen *, int);
tFitness fms(const tGen *,int);
tFitness sle(const tGen *,int);
tFitness cheb9(const tGen *, int);
tFitness schwefel_12(const tGen *, int);
tFitness ef10(const tGen *, int);
tFitness bohachevsky(const tGen *, int);
tFitness watson(const tGen *, int);
tFitness bump(const tGen *x, int n); 
tFitness fcigtab(const tGen *x, int ndim);
tFitness ruido2(const tGen *x, int ndim);
tFitness maximo_x(const tGen *x, int ndim);
tFitness suma_producto(const tGen *x, int ndim);



tFitness f_3(const tGen *,int);
tFitness f_4(const tGen *,int);
tFitness f_5(const tGen *,int);
tFitness f_6(const tGen *,int);
tFitness f_8(const tGen *,int);
tFitness f_10(const tGen *,int);
tFitness f_11(const tGen *,int);
tFitness f_12(const tGen *,int);
tFitness f_13(const tGen *,int);
tFitness f_14(const tGen *,int);
tFitness f_15(const tGen *,int);
tFitness fschaffer(const tGen *, int); 
tFitness f8f2(const tGen *, int); 
tFitness fschwefelmult(const tGen *x, int n);

tFitness objfn(const tGen *x, int nvar);
tFitness salomon(const tGen *x, int nvar); 
tFitness whitely(const tGen *x, int nvar); 
tFitness pn1(const tGen *x, int nvar);
tFitness pn2(const tGen *x, int nvar);
tFitness foxhole(const tGen *xs, int nvar);

#endif 
