/**
 * Copyright 2008, Daniel Molina Cabrera <danimolina@gmail.com>
 * 
 * This file is part of software Realea
 * 
 * Realea is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Realea is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _PROBLEM_BBOB2009_H

#define _PROBLEM_BBOB2009_H 1

#include <realea/common/problemfactory.h>
extern "C" {
#include "bbob2009/bbobStructures.h" /* Include all declarations for BBOB calls */
}


namespace realea {

class ProblemBBOB2009 : public ProblemFactory {
   public:
       /**
	* Init the problem
	*
	* @param algname Algorithm name (for output)
	* @param resultpath Directory in which store the results (for output)
	* @param dim dimension
	* @param instance instance
	*/
       ProblemBBOB2009(string algname, string resultpath, unsigned int dim, int instance);
       ~ProblemBBOB2009(void);
       ProblemPtr get(unsigned int ident=1);
       /**
	* Enable the BBOB2009 library
	*/
       void init(unsigned int fun); 

    private:
	unsigned int m_ndim, m_instance;
	bool m_init;
	string m_algname, m_resultpath;
};

}


#endif
