/**
 * Copyright 2008, Daniel Molina Cabrera <danimolina@gmail.com>
 * 
 * This file is part of software Realea
 * 
 * Realea is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Realea is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "problemtest.h"
#include "functions.h"
#include <cmath>

using namespace realea;

ProblemTest::ProblemTest(unsigned int dim)  {
   m_ndim = dim;
}

ProblemTest::~ProblemTest(void) {
}

tFitness sphere_test(const tGen *x, int n)
{
	int i;
	tFitness sum;

	sum = 0.0;
	for (i = 0; i < n; i++) {
		sum += fabs(x[i]+i);
	}

	return (sum);
}



ProblemPtr ProblemTest::get(unsigned int fun) {
    ProblemPtr prob (new Problem());
    prob->setDimension(m_ndim);
    int ndim = m_ndim;
    double min = -2.5;
    double max = 3;

    for (unsigned i = 0; i < m_ndim; ++i) {
	prob->setDomainValues(i, min, max, true);
    }

    prob->setOptimize(0, 0);
    prob->setMaxEval(1000);
    prob->setMinimize();

    // Defino la función de fitness
    prob->setEval(sphere_test);

    return prob;
}
